#include <iostream>

using namespace std;
#include<cmath>
#include<algorithm>
#include <bits/stdc++.h>


int main(int argc, char** argv)
 {
     ios::sync_with_stdio(false);
     cin.tie(0);
     
     
     int t;
     cin>>t;
     
     int p[t];
     for(int j=0;j<t;j++)
     {
	 
     int s=33;
     int n,m;
      cin>>n>>m;
      int a[n];
      int b[m];
      for(int i=0;i<n;i++)
	  {
	  	cin>>a[i];
	  }
	  
	  
	   for(int i=0;i<m;i++)
	  {
	  	cin>>b[i];
	  }
	  
	  
	  
            
			int q = 0;
            sort(a,a+n);
            int razlika = a[1] - a[0];
            for (int i = 1; i < n-1; i++)
            {

                int o = abs(a[i]-a[i+1]);

                if (max(razlika,o) % min(razlika, o) == 0)
                {
                    if (razlika > o)
                        razlika = o;


                    
                }
                else
                {
                    q = 1;
                    break;
                }

            }
            
            if (q == 0)
            {
               for(int i=0;i<m;i++)
			   {
			   	if(abs(a[0]-b[i])%razlika==0)
			   	{
				   
			   	s=0;
			   	break;
			   }
            }
            }
            if(s==33)
			{
				
		     p[j]=1;
			}
			else
			{
				p[j]=0;
			}
}
            for(int i=0;i<t;i++)
			{
				cout<<p[i]<<endl;
				
			}
            
}